# coding: utf-8

"""
    DLCM-Solution

    DLCM application wrapping all modules, All-In-One  # noqa: E501

    The version of the OpenAPI document: 2.1.1
    Contact: eresearch-opensource@unige.ch
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from dlcmapi_client.configuration import Configuration


class PreservationPolicy(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'links': 'object',
        'creation': 'ChangeInfo',
        'disposition_approval': 'bool',
        'last_update': 'ChangeInfo',
        'name': 'str',
        'res_id': 'str',
        'retention': 'float',
        'smart_retention': 'str',
        'use_number': 'float'
    }

    attribute_map = {
        'links': '_links',
        'creation': 'creation',
        'disposition_approval': 'dispositionApproval',
        'last_update': 'lastUpdate',
        'name': 'name',
        'res_id': 'resId',
        'retention': 'retention',
        'smart_retention': 'smartRetention',
        'use_number': 'useNumber'
    }

    def __init__(self, links=None, creation=None, disposition_approval=None, last_update=None, name=None, res_id=None, retention=None, smart_retention=None, use_number=None, local_vars_configuration=None):  # noqa: E501
        """PreservationPolicy - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._links = None
        self._creation = None
        self._disposition_approval = None
        self._last_update = None
        self._name = None
        self._res_id = None
        self._retention = None
        self._smart_retention = None
        self._use_number = None
        self.discriminator = None

        if links is not None:
            self.links = links
        if creation is not None:
            self.creation = creation
        if disposition_approval is not None:
            self.disposition_approval = disposition_approval
        if last_update is not None:
            self.last_update = last_update
        if name is not None:
            self.name = name
        if res_id is not None:
            self.res_id = res_id
        if retention is not None:
            self.retention = retention
        if smart_retention is not None:
            self.smart_retention = smart_retention
        if use_number is not None:
            self.use_number = use_number

    @property
    def links(self):
        """Gets the links of this PreservationPolicy.  # noqa: E501

        The _links_ list of the _preservation-policies_ resource  # noqa: E501

        :return: The links of this PreservationPolicy.  # noqa: E501
        :rtype: object
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this PreservationPolicy.

        The _links_ list of the _preservation-policies_ resource  # noqa: E501

        :param links: The links of this PreservationPolicy.  # noqa: E501
        :type: object
        """

        self._links = links

    @property
    def creation(self):
        """Gets the creation of this PreservationPolicy.  # noqa: E501


        :return: The creation of this PreservationPolicy.  # noqa: E501
        :rtype: ChangeInfo
        """
        return self._creation

    @creation.setter
    def creation(self, creation):
        """Sets the creation of this PreservationPolicy.


        :param creation: The creation of this PreservationPolicy.  # noqa: E501
        :type: ChangeInfo
        """

        self._creation = creation

    @property
    def disposition_approval(self):
        """Gets the disposition_approval of this PreservationPolicy.  # noqa: E501

        Mandatory step to approve the AIP disposition  # noqa: E501

        :return: The disposition_approval of this PreservationPolicy.  # noqa: E501
        :rtype: bool
        """
        return self._disposition_approval

    @disposition_approval.setter
    def disposition_approval(self, disposition_approval):
        """Sets the disposition_approval of this PreservationPolicy.

        Mandatory step to approve the AIP disposition  # noqa: E501

        :param disposition_approval: The disposition_approval of this PreservationPolicy.  # noqa: E501
        :type: bool
        """

        self._disposition_approval = disposition_approval

    @property
    def last_update(self):
        """Gets the last_update of this PreservationPolicy.  # noqa: E501


        :return: The last_update of this PreservationPolicy.  # noqa: E501
        :rtype: ChangeInfo
        """
        return self._last_update

    @last_update.setter
    def last_update(self, last_update):
        """Sets the last_update of this PreservationPolicy.


        :param last_update: The last_update of this PreservationPolicy.  # noqa: E501
        :type: ChangeInfo
        """

        self._last_update = last_update

    @property
    def name(self):
        """Gets the name of this PreservationPolicy.  # noqa: E501

        The name of the preservation policy  # noqa: E501

        :return: The name of this PreservationPolicy.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this PreservationPolicy.

        The name of the preservation policy  # noqa: E501

        :param name: The name of this PreservationPolicy.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def res_id(self):
        """Gets the res_id of this PreservationPolicy.  # noqa: E501

        The _preservation-policies_ resource identifier [https://en.wikipedia.org/wiki/Universally_unique_identifier[UUID]]  # noqa: E501

        :return: The res_id of this PreservationPolicy.  # noqa: E501
        :rtype: str
        """
        return self._res_id

    @res_id.setter
    def res_id(self, res_id):
        """Sets the res_id of this PreservationPolicy.

        The _preservation-policies_ resource identifier [https://en.wikipedia.org/wiki/Universally_unique_identifier[UUID]]  # noqa: E501

        :param res_id: The res_id of this PreservationPolicy.  # noqa: E501
        :type: str
        """

        self._res_id = res_id

    @property
    def retention(self):
        """Gets the retention of this PreservationPolicy.  # noqa: E501

        The retention duration in days of the preservation policy  # noqa: E501

        :return: The retention of this PreservationPolicy.  # noqa: E501
        :rtype: float
        """
        return self._retention

    @retention.setter
    def retention(self, retention):
        """Sets the retention of this PreservationPolicy.

        The retention duration in days of the preservation policy  # noqa: E501

        :param retention: The retention of this PreservationPolicy.  # noqa: E501
        :type: float
        """

        self._retention = retention

    @property
    def smart_retention(self):
        """Gets the smart_retention of this PreservationPolicy.  # noqa: E501

        The retention duration in human-readable format of the preservation policy  # noqa: E501

        :return: The smart_retention of this PreservationPolicy.  # noqa: E501
        :rtype: str
        """
        return self._smart_retention

    @smart_retention.setter
    def smart_retention(self, smart_retention):
        """Sets the smart_retention of this PreservationPolicy.

        The retention duration in human-readable format of the preservation policy  # noqa: E501

        :param smart_retention: The smart_retention of this PreservationPolicy.  # noqa: E501
        :type: str
        """

        self._smart_retention = smart_retention

    @property
    def use_number(self):
        """Gets the use_number of this PreservationPolicy.  # noqa: E501

        Use number in organizational units of the preservation policy  # noqa: E501

        :return: The use_number of this PreservationPolicy.  # noqa: E501
        :rtype: float
        """
        return self._use_number

    @use_number.setter
    def use_number(self, use_number):
        """Sets the use_number of this PreservationPolicy.

        Use number in organizational units of the preservation policy  # noqa: E501

        :param use_number: The use_number of this PreservationPolicy.  # noqa: E501
        :type: float
        """

        self._use_number = use_number

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PreservationPolicy):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, PreservationPolicy):
            return True

        return self.to_dict() != other.to_dict()
